'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var chunkOOROZIU6_js = require('./chunk-OOROZIU6.js');

// src/logic/isArrayEmpty.ts
function isArrayEmpty({ arr }) {
  for (const name in arr) {
    if (Number.isNaN(+name))
      return true;
    return false;
  }
  return true;
}

// src/logic/Table.ts
function getExtendsPropertyDescriptors(data) {
  if (data === null || typeof data !== "object")
    return;
  if (chunkOOROZIU6_js.isBuffer(data))
    return chunkOOROZIU6_js.getOwnDescriptorsBuffer(data);
  if (chunkOOROZIU6_js.isCollection(data))
    return chunkOOROZIU6_js.getOwnDescriptorsCollection(data);
  if (chunkOOROZIU6_js.isDataView(data))
    return chunkOOROZIU6_js.getOwnDescriptorsDataView(data);
  if (chunkOOROZIU6_js.isRegExp(data))
    return chunkOOROZIU6_js.getOwnDescriptorsRegExp(data);
  if (chunkOOROZIU6_js.isTypedArray(data))
    return chunkOOROZIU6_js.getOwnDescriptorsTypedArray(data);
  return void 0;
}
function getDescriptors(data) {
  return Object.assign(
    chunkOOROZIU6_js.getOwnDescriptorsIn(data),
    Object.getOwnPropertyDescriptors(data),
    getExtendsPropertyDescriptors(data)
  );
}
function Table(data, deepLink, noCollapse) {
  const table = {};
  const nameCols = /* @__PURE__ */ new Set();
  chunkOOROZIU6_js.entries(getDescriptors(data)).forEach(([name, meta]) => {
    name = name.toString();
    const { value } = meta;
    let isArray;
    if (value !== null && typeof value === "object" && (!(isArray = Array.isArray(value)) || !isArrayEmpty({ arr: value }))) {
      const row = table[name] = {};
      chunkOOROZIU6_js.entries(getDescriptors(value)).forEach(([propName, propMeta]) => {
        if (isArray && propName === "length")
          return;
        propName = propName.toString();
        nameCols.add(propName);
        row[propName] = chunkOOROZIU6_js.createPreviewValue(propMeta.value);
      });
    } else {
      nameCols.add("Values");
      table[name] = {
        Values: chunkOOROZIU6_js.createPreviewValue(value)
      };
    }
  });
  return {
    table,
    cols: Array.from(nameCols.values()),
    "@location": deepLink === false ? null : chunkOOROZIU6_js.getLocationCall(deepLink),
    "@collapse": noCollapse ? void 0 : chunkOOROZIU6_js.Encode(data, false)
  };
}

exports.Table = Table;
